// Copyright (c) 2016, 2018, 2024, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// DevOps API
//
// Use the DevOps API to create DevOps projects, configure code repositories,  add artifacts to deploy, build and test software applications, configure  target deployment environments, and deploy software applications.  For more information, see DevOps (https://docs.cloud.oracle.com/Content/devops/using/home.htm).
//

package devops

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// PullRequestChangeSummaryMetrics Response object for obtaining summary metric of Pull Request changed files.
type PullRequestChangeSummaryMetrics struct {

	// The number of lines added in whole difference.
	ChangedFilesCount *int `mandatory:"true" json:"changedFilesCount"`

	// The number of lines added in whole difference.
	AddedLinesCount *int `mandatory:"true" json:"addedLinesCount"`

	// The number of lines deleted in whole difference.
	DeletedLinesCount *int `mandatory:"true" json:"deletedLinesCount"`
}

func (m PullRequestChangeSummaryMetrics) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m PullRequestChangeSummaryMetrics) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
